/*
 * Copyright (c) 2026 University of Insubria <https://www.uninsubria.it>
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version. All we ask is that proper credit is given
 * for our work, which includes - but is not limited to - adding the above
 * copyright notice to the beginning of your source code files, and to any
 * copyright notice that you may distribute with programs based on this work.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation, Inc.
 * <https://fsf.org/>
 */

package qsardes.atomconst;

import qsardes.elements.ElementsEnum;
import qsardes.molecule.Molecule;
import java.util.HashMap;
import java.util.Map;
import org.openscience.cdk.interfaces.IAtom;
import org.openscience.cdk.interfaces.IAtomContainer;

/**
 * Gets the van der Waals atomic radius.
 *
 * @author Nicola Chirico
 */
public final class AtomConstVanWRad implements AtomConstFunctionCall
{
    public AtomConstVanWRad()
    {
    }

    @Override
    public AtomConstResult call(Molecule mol)
    {
        IAtomContainer iac = mol.get_atom_container();

        final int ATOM_COUNT = iac.getAtomCount();

        Map<IAtom, Double> map = new HashMap<>();
        double[] const_val = new double[ATOM_COUNT];

        for (int i = 0; i < ATOM_COUNT; i++) {
            IAtom atom = iac.getAtom(i);

            double value = ElementsEnum.valueOf(atom.getSymbol())
                    .get_van_der_waals_radius();

            map.put(atom, value);
            const_val[i] = value;
        }

        return new AtomConstResult(
                ElementsEnum.valueOf("C").get_van_der_waals_radius(),
                map, const_val);
    }
}
